use serenity;

use std::process::{Command, Stdio};
use std::str::from_utf8;

pub struct IP {}

impl IP {
    pub fn new() -> IP {
        IP {}
    }
}

impl serenity::framework::standard::Command for IP {
    #[allow(unreachable_code, unused_mut)]
    fn execute(
        &self,
        _: &mut serenity::client::Context,
        msg: &serenity::model::channel::Message,
        _: serenity::framework::standard::Args,
    ) -> ::std::result::Result<(), serenity::framework::standard::CommandError> {
        let args = ["ifconfig.me"];

        let out = match Command::new("curl")
            .args(&args)
            .stdin(Stdio::null())
            .output()
        {
            Ok(out) => out,
            Err(_) => return Ok(()),
        };

        if !out.status.success() {
            return Ok(());
        }

        match from_utf8(out.stdout.as_slice()) {
            Ok(string) => print_error!(msg.channel_id.say(string)),
            Err(_) => print_error!(msg.channel_id.say("error getting IP string")),
        };

        Ok(())
    }
}
