use serenity;

use std::sync::Arc;

use super::super::prelude::*;

pub struct Stop {
    media: Arc<MediaData>,
}

impl Stop {
    pub fn new(media_data: Arc<MediaData>) -> Stop {
        Stop { media: media_data }
    }
}

impl serenity::framework::standard::Command for Stop {
    #[allow(unreachable_code, unused_mut)]
    fn execute(
        &self,
        ctx: &mut serenity::client::Context,
        msg: &serenity::model::channel::Message,
        _: serenity::framework::standard::Args,
    ) -> ::std::result::Result<(), serenity::framework::standard::CommandError> {
        print_error!(self.media.reset(ctx, msg));

        Ok(())
    }
}
